package brokerdriver

import (
	"fmt"
	"query-service/pkg/logger"

	"github.com/streadway/amqp"
	"github.com/thijsheijden/alice"
)

// AliceProducer models a RabbitMQ producer in Alice
type AliceProducer struct {
	broker   *Driver
	producer alice.Producer
}

// PublishMessage will publish a message to the specified queue id
func (ap *AliceProducer) PublishMessage(body *[]byte, queueID *string, headers *amqp.Table) {
	sessionID := (*headers)["sessionID"]
	logger.Log(fmt.Sprintf("Publishing message to queue %v, for session %v", *queueID, sessionID))

	ap.producer.PublishMessage(*body, queueID, headers)
}
